Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/SimpleEndpointSearchEngineBase.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/SimpleEndpointSearchEngineBase.java	(revision 5546)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/SimpleEndpointSearchEngineBase.java	(revision 5547)
@@ -543,79 +543,3 @@
     }
 
-
-//             final boolean defaultNS = ((prefix == null) || prefix.isEmpty());
-//            if (writeNS) {
-//                 if (defaultNS) {
-//                     writer.setDefaultNamespace(FCS_RESOURCE_INFO_NS);
-//                } else {
-//                    writer.setPrefix(prefix, FCS_RESOURCE_INFO_NS);
-//                }
-//            }
-//            writer.writeStartElement(FCS_RESOURCE_INFO_NS, "ResourceInfo");
-//            if (writeNS) {
-//                if (defaultNS) {
-//                    writer.writeDefaultNamespace(FCS_RESOURCE_INFO_NS);
-//                 } else {
-//                    writer.writeNamespace(prefix, FCS_RESOURCE_INFO_NS);
-//                 }
-//          } )
-//}
-
-//    public static void XwriteResourceInfo(XMLStreamWriter writer, String prefix,
-//            ResourceInfo resourceInfo) throws XMLStreamException {
-//        doWriteResourceInfo(writer, prefix, resourceInfo, true, false);
-//    }
-//
-//
-//    private static void XdoWriteResourceInfo(XMLStreamWriter writer,
-//            String prefix, ResourceInfo resourceInfo, boolean writeNS,
-//            boolean recursive) throws XMLStreamException {
-//
-//        if (writer == null) {
-//            throw new NullPointerException("writer == null");
-//        }
-//        if (resourceInfo == null) {
-//            throw new NullPointerException("resourceInfo == null");
-//        }
-//
-//        final boolean defaultNS = ((prefix == null) || prefix.isEmpty());
-//        if (writeNS) {
-//            if (defaultNS) {
-//                writer.setDefaultNamespace(FCS_RESOURCE_INFO_NS);
-//            } else {
-//                writer.setPrefix(prefix, FCS_RESOURCE_INFO_NS);
-//            }
-//        }
-//        writer.writeStartElement(FCS_RESOURCE_INFO_NS, "Resource");
-//        if (writeNS) {
-//            if (defaultNS) {
-//                writer.writeDefaultNamespace(FCS_RESOURCE_INFO_NS);
-//            } else {
-//                writer.writeNamespace(prefix, FCS_RESOURCE_INFO_NS);
-//            }
-//        }
-//        if (recursive) {
-//            /*
-//             * HACK: only output @pid for recursive (= explain) requests.
-//             * This should be revisited, if we decide to go for the explain
-//             * style enumeration of resources.
-//             */
-//            writer.writeAttribute("pid", resourceInfo.getPid());
-//        }
-//        if (resourceInfo.hasSubResources()) {
-//            writer.writeAttribute("hasSubResources", "true");
-//        }
-//
-//
-//        if (recursive && resourceInfo.hasSubResources()) {
-//            writer.writeStartElement(FCS_RESOURCE_INFO_NS,
-//                    "ResourceInfoCollection");
-//            for (ResourceInfo r : resourceInfo.getSubResources()) {
-//                doWriteResourceInfo(writer, prefix, r, writeNS, recursive);
-//            }
-//            writer.writeEndElement(); // "ResourceCollection" element
-//        }
-//        writer.writeEndElement(); // "ResourceInfo" element
-//    }
-
 } // class SimpleEndpointSearchEngineBase
Index: /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/SimpleEndpointDescriptionParser.java
===================================================================
--- /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/SimpleEndpointDescriptionParser.java	(revision 5546)
+++ /FCSSimpleEndpoint/trunk/src/main/java/eu/clarin/sru/server/fcs/utils/SimpleEndpointDescriptionParser.java	(revision 5547)
@@ -526,7 +526,3 @@
     }
 
-
-//    private static List<ResourceInfo> parseLegacy(Document doc)
-//            throws SRUConfigException, XPathExpressionException {
-
 } // class SimpleResourceInfoInventoryParser