Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/AuthenticationStatePanel.html
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/AuthenticationStatePanel.html	(revision 5558)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/AuthenticationStatePanel.html	(revision 5559)
@@ -9,5 +9,7 @@
 <div wicket:id="login"></div>
 <wicket:fragment wicket:id="loginFragment">
-  Anonymous <a wicket:id="loginLink" href="#">[Login]</a>
+    <a wicket:id="loginLink" id="login" class="glyphicon glyphicon-log-in" href="#">
+        <span>LOGIN</span>
+    </a>
 </wicket:fragment>
 
@@ -15,5 +17,5 @@
 <wicket:fragment wicket:id="logoutFragment">
   <span wicket:id="username">username</span>
-  <!-- <a wicket:id="logoutLink" href="#">[Logout]</a>  -->
+    <!--<a wicket:id="logoutLink" id="logout" class="glyphicon glyphicon-log-out" href="#"><span>LOGOUT</span></a>-->
 </wicket:fragment>
 </wicket:panel>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/BasePage.html
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/BasePage.html	(revision 5558)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/BasePage.html	(revision 5559)
@@ -1,37 +1,60 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
-                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
+    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:wicket="http://wicket.apache.org/">
-  <head>
-    <title>CLARIN Virtual Collection Registry</title>
-    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
-    <link href="css/vcr.css" rel="stylesheet" type="text/css" />
-  </head>
-  <body>
-    <noscript>
-      <div id="noscript-warning">Virtual Collection Registry requires JavaScript to be enabled!</div>
-    </noscript>
-    <div id="container">
-      <div id="header">
-        <div id="header-logo">
-          <div id="clarin-logo" />
-          <div id="ids-logo"/>
-          <h1>Virtual Collection Registry</h1>
+    <head>
+        <title>CLARIN Virtual Collection Registry</title>
+        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+        <link href="css/vcr.css" rel="stylesheet" type="text/css" />
+        <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css">
+    </head>
+    <body>
+        <noscript>
+            <div id="noscript-warning">Virtual Collection Registry requires JavaScript to be enabled!</div>
+        </noscript>
+
+
+        <div id="body">
+            <div class="navbar navbar-default navbar-fixed-top" role="navigation">
+                <div class="container">
+                    <div class="navbar-header">
+                        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
+                            <span class="sr-only">Toggle navigation</span>
+                            <span class="icon-bar"></span>
+                            <span class="icon-bar"></span>
+                            <span class="icon-bar"></span>
+                        </button>
+                        <a class="navbar-brand" href="/"><header>Virtual Collection Registry</header></a>
+                    </div>
+
+                    <div class="navbar-collapse collapse">
+                        <wicket:container wicket:id="menu"></wicket:container>
+                        <ul id="CLARIN_header_right" class="nav navbar-nav navbar-right">
+                            <li wicket:id="authstate">[auth]</li>
+                        </ul>
+                    </div>
+                </div>
+            </div>
+            <div id="push"></div>
+            <div class="container">
+                <div id="feedback" wicket:id="feedback">[Feedback]</div>
+                <wicket:child />
+            </div>
         </div>
-        <div id="navigation">
-          <div id="menu" wicket:id="menu"></div>
-          <div id="login">
-            <div wicket:id="authstate"></div>
-          </div>
+
+        <div id="footer">
+            <div class="container">
+                <div id="CLARIN_footer_left">
+                    <a title="about" href="?view=about"><span>VERSION ${pom.version} </span><span class="glyphicon glyphicon-info-sign"></span></a>
+                </div>
+                <div id="CLARIN_footer_middle">
+                    <a title="CLARIN ERIC" href="https://www.clarin.eu/"><img src="//infra.clarin.eu/content/CLARIN-logo-4C14-60pxh.png" alt="CLARIN ERIC logo"/></a>
+                </div>
+                <div id="CLARIN_footer_right">
+                    <a title="contact" class="glyphicon glyphicon-envelope" href="mailto:centre-registry@clarin.eu"><span> CONTACT</span></a>
+                </div>
+            </div>
         </div>
-      </div>
-      <div id="feedback" wicket:id="feedback">[Feedback]</div>
-      <div id="content"><wicket:child /></div>
-      <div class="push"></div>
-    </div>
-    <div id="footer">
-      Version ${pom.version}      
-    </div>
-  </body>
+    </body>
 </html>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/Menu.html
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/Menu.html	(revision 5558)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/Menu.html	(revision 5559)
@@ -1,16 +1,16 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
-                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
+    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:wicket="http://wicket.apache.org/">
-<head />
-<body>
-<wicket:panel>
-<div id="menu">
-  <ul>
-    <li wicket:id="menuitems"><div wicket:id="menuitem"></div></li>
-  </ul>
-</div>
-</wicket:panel>
-</body>
+    <head />
+    <body>
+        <wicket:panel>
+            <ul class="nav navbar-nav">
+                <wicket:container wicket:id="menuitems">
+                    <li wicket:id="menuitem">[item]</li>
+                </wicket:container>
+            </ul>
+        </wicket:panel>
+    </body>
 </html>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/MenuItem.html
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/MenuItem.html	(revision 5558)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/MenuItem.html	(revision 5559)
@@ -1,12 +1,12 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
-                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
+    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml"
       xmlns:wicket="http://wicket.apache.org/">
-<head />
-<body>
-<wicket:panel>
-<a wicket:id="link" href="#"><span wicket:id="title">Title</span></a>
-</wicket:panel>
-</body>
+    <head />
+    <body>
+        <wicket:panel>
+            <a wicket:id="link" href="#"><span wicket:id="title">Title</span></a>
+        </wicket:panel>
+    </body>
 </html>
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/MenuItem.java
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/MenuItem.java	(revision 5558)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/java/eu/clarin/cmdi/virtualcollectionregistry/gui/pages/MenuItem.java	(revision 5559)
@@ -1,7 +1,8 @@
 package eu.clarin.cmdi.virtualcollectionregistry.gui.pages;
 
+import eu.clarin.cmdi.virtualcollectionregistry.gui.Application;
+import org.apache.wicket.AttributeModifier;
 import org.apache.wicket.authorization.IAuthorizationStrategy;
 import org.apache.wicket.authorization.strategies.role.annotations.AuthorizeAction;
-import org.apache.wicket.markup.ComponentTag;
 import org.apache.wicket.markup.html.WebPage;
 import org.apache.wicket.markup.html.basic.Label;
@@ -9,11 +10,12 @@
 import org.apache.wicket.markup.html.link.Link;
 import org.apache.wicket.markup.html.panel.Panel;
+import org.apache.wicket.model.AbstractReadOnlyModel;
 import org.apache.wicket.model.IModel;
+import org.apache.wicket.model.Model;
 import org.apache.wicket.util.lang.Classes;
-
-import eu.clarin.cmdi.virtualcollectionregistry.gui.Application;
 
 @SuppressWarnings("serial")
 public class MenuItem<T extends WebPage> extends Panel {
+
     private static final String ENABLE = "ENABLE";
     private final String pageClassName;
@@ -22,30 +24,31 @@
         super("menuitem");
         this.pageClassName = pageClass.getName();
-        setRenderBodyOnly(true);
-        final Link<T> link = new BookmarkablePageLink<T>("link", pageClass) {
+        final Link<T> link = new BookmarkablePageLink<T>("link", pageClass)
+                .setAutoEnable(false);
+        link.add(new Label("title", title).setRenderBodyOnly(true));
+        add(link);
+
+        add(new AttributeModifier("class", true, new AbstractReadOnlyModel<String>() {
             @Override
-            protected void onComponentTag(ComponentTag tag) {
-                super.onComponentTag(tag);
-                if (linksTo(getPage())) {
-                    tag.setName("span");
-                    tag.getAttributes().remove("href");
-                    tag.getAttributes().put("class", "active");
+            public String getObject() {
+                if (pageClass.equals(getPage().getClass())) {
+                    return "active";
+                } else {
+                    return null;
                 }
             }
-        };
-        link.add(new Label("title", title).setRenderBodyOnly(true));
-        add(link);
+        }));
     }
 
     @Override
     protected void onBeforeRender() {
-        final IAuthorizationStrategy strategy =
-            getApplication().getSecuritySettings()
+        final IAuthorizationStrategy strategy
+                = getApplication().getSecuritySettings()
                 .getAuthorizationStrategy();
         final Class<T> pageClass = getPageClass();
         if (!strategy.isInstantiationAuthorized(pageClass)) {
             boolean visible = true;
-            AuthorizeAction action =
-                pageClass.getAnnotation(AuthorizeAction.class);
+            AuthorizeAction action
+                    = pageClass.getAnnotation(AuthorizeAction.class);
             if ((action != null) && ENABLE.equalsIgnoreCase(action.action())) {
                 final Application app = (Application) getApplication();
Index: /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/css/vcr.scss
===================================================================
--- /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/css/vcr.scss	(revision 5558)
+++ /VirtualCollectionRegistry/trunk/VirtualCollectionRegistry/src/main/webapp/css/vcr.scss	(revision 5559)
@@ -1,24 +1,3 @@
-* {
-    margin: 0;
-    /*    padding: 0; */	
-}
-
-html {
-    overflow-y: scroll
-}
-
-html, body {
-    font-family: Verdana, sans-serif;
-    font-size: 12px;
-    margin: 0 auto;
-    padding: 0;
-    line-height: 1;
-    height: 100%;
-    color: #000000;
-    /*    background-color: #E9EEFA; */
-    width: 990px;
-    min-width: 990px;
-    height: 100%;
-}
+@import 'CLARIN';
 
 noscript {
@@ -46,143 +25,4 @@
 }
 
-#header {
-    border-top: 2px solid #D4DEEF;
-}
-
-#header-logo {
-    margin: 0;
-    padding: 5px; 
-    height: 70px;
-    color: #004071;
-    background-color: #E9EEF7;
-}
-
-#header-logo #clarin-logo {
-    background: transparent url('../images/clarin-logo.png') no-repeat;
-    float: left;
-    width: 298px;
-    height: 70px;
-}
-
-#header-logo #ids-logo {
-    background: transparent url('../images/ids-logo.png') no-repeat;
-    float: right;
-    width: 55px;
-    height: 70px;
-}
-
-#header-logo h1 {
-    margin: 0 55px 0 298px;
-    padding: 0 32px 0 32px;
-    height: 70px;
-    line-height: 70px;
-    font-size: 34px;
-    font-weight: bold;
-    font-variant: small-caps;
-}
-
-#navigation {
-    margin: 0;
-    padding: 0;
-    height: 20px;
-    clear: both;
-    color: #000000;
-    background-color: #D4DEEF;
-    font-size: 12px;
-    line-height: 12px;
-    vertical-align: middle;
-}
-
-#menu {
-    margin: 0 100px 0 0;
-}
-
-#menu ul {
-    list-style-type: none;
-    margin: 0;
-    padding: 0;
-}
-
-#menu li {
-    float: left;
-    margin-left: 4px;
-}
-
-#menu a, #menu span.active {
-    display: block;
-    margin: 0;
-    padding: 4px 8px;
-    width: auto;
-    height: 12px;
-    text-align: center;
-    text-decoration: none;
-    font-weight: bold;
-}
-
-#menu ul li + #menu ul li {
-    border-left: 1px solid black;
-}
-
-#menu a, #menu a:active, #menu a:visited {
-    color: #000000;
-    background-color: inherit;
-}
-
-#menu a:hover {
-    color: #AE0000;
-    background-color: #E9EEF7;
-}
-
-#menu span.active {
-    font-style: italic;
-}
-
-#login {
-    float: right;
-    padding: 4px 4px 4px 4px;
-    width: auto;
-}
-
-#container {
-    min-height: 100%;
-    height: auto !important;
-    height: 100%;
-    margin: 0 auto -20px; /* the bottom margin is the negative value of the footer's height */
-    color: #000000;
-    background-color: #FFFFFF;
-    border-left: 2px solid #D4DEEF;
-    border-right: 2px solid #D4DEEF;
-}
-
-#content {
-    margin: 0;
-    padding: 0;
-}
-
-#container .push {
-    height: 20px;
-    width: auto;
-}
-
-#footer {
-    padding: 0 4px;
-    margin: 0 auto;
-    height: 18px;
-    line-height: 18px;
-    text-align: right;
-    color: #004071;
-    background-color: #D4DEEF;
-    border-left: 2px solid #D4DEEF;
-    border-right: 2px solid #D4DEEF;
-    border-bottom: 2px solid #D4DEEF;
-}
-
-/* general */
-input, select, textarea {
-    font-family: Verdana, sans-serif;
-    font-size: 100%;
-    border: 1px solid #000000;
-}
-
 /*
  * wizard
@@ -221,33 +61,4 @@
     margin: 0 0 0 0;
 }
-
-/*
-form.wizard fieldset legend {
-  font-size: 150%;
-  font-weight: normal;
-  color: #000000;
-  margin: 0 0 0 0;
-  padding: 0 5px;
-}
-
-div.wizard label {
-  font-size: 100%;
-}
-
-div.wizard label u {
-  font-style: normal;
-  text-decoration: underline;
-}
-
-div.wizard input, div.wizard select, div.wizard textarea {
-  font-family: Tahoma, Arial, sans-serif; 
-  font-size: 100%;
-  color: #000000;
-}
-
-div.wizard textarea {
-  overflow: auto;
-}
-*/
 
 form.wizard div,
@@ -342,14 +153,4 @@
 }
 
-/*
-div.optional label:after {
-  content: ':';
-}
-
-div.required label:after {
-  content: ':';
-}
-*/
-
 form.wizard textarea {
     font-family: Verdana, sans-serif;
@@ -374,127 +175,4 @@
 }
 
-/*
-form.wizard div label.labelCheckbox, form div label.labelRadio {
-  float: none;
-  display: block;
-  width: 200px;
-  zoom: 1;
-  padding: 0;
-  margin: 0 0 5px 142px;
-  text-align: left;
-}
-
-form.wizard div fieldset label.labelCheckbox, form div fieldset label.labelRadio {
-  margin: 0 0 5px 0;
-  width: 170px;
-}
-
-form.wizard div img {
-  float: left;
-  border: 1px solid #000000;
-  margin: 0 0 5px 0;
-}
-
-p.error {
-  background-color: #ff0000;
-  background-image: url(/images/icon_error.gif);
-  background-repeat: no-repeat;
-  background-position: 3px 3px;
-  color: #ffffff;
-  padding: 3px 3px 5px 27px;
-  border: 1px solid #000000;
-  margin: auto 100px;
-}
-
-form.wizard div.error {
-  background-color: #ffffe1;
-  background-image: url(/images/required_bg.gif);
-  background-repeat: no-repeat;
-  background-position: top left;
-  color: #666666;
-  border: 1px solid #ff0000;
-}
-
-form.wizard div.error p.error {
-  background-image: url(/images/icon_error.gif);
-  background-position: top left;
-  background-color: transparent;
-  border-style: none;
-  font-size: 88%;
-  font-weight: bold;
-  margin: 0 0 0 118px;
-  width: 200px;
-  color: #ff0000;
-}
-
-form.wizard div select, form div textarea {
-  width: 200px;
-  padding: 1px 3px;
-  margin: 0 0 0 0;
-}
-
-form.wizard div input.inputText, form div input.inputPassword {
-  width: 200px;
-  padding: 1px 3px;
-  margin: 0 0 0 0;
-}
-
-form.wizard div input.inputFile {
-  width: 211px;
-}
-
-form.wizard div select.selectOne, form div select.selectMultiple {
-  width: 211px;
-  padding: 1px 3px;
-}
-
-form.wizard div input.inputCheckbox, form div input.inputRadio, input.inputCheckbox, input.inputRadio {
-  display: inline;
-  height: auto;
-  width: auto;
-  background-color: transparent;
-  border-width: 0;
-  padding: 0;
-  margin: 0 0 0 140px;
-}
-
-form.wizard div.submit {
-  width: 214px;
-  padding: 0 0 0 146px;
-}
-
-form.wizard div.submit div {
-  display: inline;
-  float: left;
-  text-align: left;
-  width: auto;
-  padding: 0;
-  margin: 0;
-}
-
-form.wizard div input.inputSubmit,
-form div input.inputButton, input.inputSubmit, input.inputButton {
-  background-color: #cccccc;
-  color: #000000;
-  width: auto;
-  padding: 0 6px;
-  margin: 0;
-}
-
-form.wizard div.submit div input.inputSubmit,
-form div.submit div input.inputButton {
-  float: right;
-  margin: 0 0 0 5px;
-}
-
-form.wizard div small {
-  display: block;
-  margin: 0 0 5px 142px;
-  padding: 1px 3px;
-  font-size: 88%;
-  zoom: 1;
-}
-*/
-
 form.wizard .wizardButtons {
     border-top: 1px solid #000000;
@@ -509,8 +187,4 @@
 }
 
-/*
-form.wizard .buttonbar input.button,
-div.modalDialog div.modalDialogButtons input.button
-*/
 input.button {
     padding: 1px 4px;
@@ -537,5 +211,4 @@
 }
 
-
 /*
  * modal dialog
@@ -626,5 +299,5 @@
 }
 
-
+/*
 table {
     font-size: 100%;
@@ -645,5 +318,5 @@
     border-top: 1px solid #000000;
     border-bottom: 1px solid #000000;
-}
+}*/
 
 table td.action {
@@ -672,24 +345,5 @@
 }
 
-a {
-    color: #AE0000;
-    background-color: inherit;
-    text-decoration: none;
-}
-
-table tbody {
-    border-bottom: 1px solid #000000;
-}
-
-table tr.even {
-    color: inherit;
-    background-color: #FFFFFF;
-}
-
-table tr.odd {
-    color: inherit;
-    background-color: #E9EEF7;
-}
-
+/*
 table td.norecords-td {
     text-align: center;
@@ -705,4 +359,5 @@
     clear: none !important;
 }
+*/
 
 table.creatorsTable,